#include "helper.h"

int current_first_track = 0; // FIXME: global

void on_rename_track(GtkCellRendererText *cellrenderertext, gchar *arg1,
                     gchar *arg2, gpointer data) {
  GtkTreePath *path = gtk_tree_path_new_from_string(arg1);
  GtkTreeStore *store2 = GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(lookup_widget(a, "treeview5"))));
  GtkTreeIter iter;
  int num = gtk_tree_path_get_indices(path)[0];
  printf("rename_track(%d, '%s')\n", current_first_track + num, arg2);
  if (netmd_rename_track(md, current_first_track + num, arg2)) {
    if (gtk_tree_model_get_iter(GTK_TREE_MODEL(store2), &iter, path))
      gtk_tree_store_set(store2, &iter, TITLE_COLUMN, arg2, -1);
  } else {
    // notify user and refresh display
  }
  gtk_tree_path_free(path);
}

void on_rename_group(GtkCellRendererText *cellrenderertext, gchar *arg1,
                     gchar *arg2, gpointer data) {
  GtkTreePath *path = gtk_tree_path_new_from_string(arg1);
  GtkTreeStore *store1 = GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(lookup_widget(a, "treeview4"))));
  GtkTreeIter iter;
  int num;

  switch(gtk_tree_path_get_depth(path)) {
    case 1:
      printf("rename_disc('%s')\n", arg2);
      break;
    case 3:
      num = gtk_tree_path_get_indices(path)[gtk_tree_path_get_depth(path)-1];
      printf("rename_group(%d, '%s')\n", num, arg2);
      if (netmd_rename_group(md, num, arg2)) {
        if (gtk_tree_model_get_iter(GTK_TREE_MODEL(store1), &iter, path))
          gtk_tree_store_set(store1, &iter, 0, arg2, -1);
      } else {
        // notify user and refresh display
      }
      break;
  }
  gtk_tree_path_free(path);
}

void mycellfunc(GtkTreeViewColumn *column, GtkCellRenderer *cell, GtkTreeModel
                *model, GtkTreeIter *iter, gpointer data) {
  switch(gtk_tree_path_get_depth(gtk_tree_model_get_path(model, iter))) {
    case 1:
      g_object_set(G_OBJECT(cell), "editable", TRUE, NULL);
      break;
    case 3:
      g_object_set(G_OBJECT(cell), "editable", TRUE, NULL);
      break;
    default:
      g_object_set(G_OBJECT(cell), "editable", FALSE, NULL);
  }
}

void on_row_activated(GtkTreeView *treeview, GtkTreePath *arg1,
                      GtkTreeViewColumn *arg2, gpointer user_data) {
  printf("play_track(%p, %p, %p)\n", treeview, arg2, user_data);
  printf("depth = %d\n", gtk_tree_path_get_depth(arg1));
  printf("num = %d\n", gtk_tree_path_get_indices(arg1)[gtk_tree_path_get_depth(arg1)-1]);
}

void on_all_tracks_selected() {
  GtkTreeView *tree2 = GTK_TREE_VIEW(lookup_widget(a, "treeview5"));
  GtkTreeStore *store2 = GTK_TREE_STORE(gtk_tree_view_get_model(tree2));
  NetMDDisc *disc = md->disc;
  int i;

  gtk_tree_store_clear(store2);

  for (i = 0; i < disc->numtracks; i++) {
    char t[32];
    GtkTreeIter iter3;
    NetMDTrack *track = disc->tracks[i];
    gtk_tree_store_append(store2, &iter3, NULL);
    gtk_tree_store_set(store2, &iter3,
                       TRACK_COLUMN, track->track_number + 1,
                       TITLE_COLUMN, track->title,
                       LENGTH_COLUMN, netmd_track_time_s(track, t, 32),
                       MODE_COLUMN, netmd_track_bitrate_s(track),
                       CODEC_COLUMN, netmd_track_codec_s(track), -1);
  }
  current_first_track = 0; // FIXME: global usage
}

void on_group_selected(int group_number) {
  GtkTreeView *tree2 = GTK_TREE_VIEW(lookup_widget(a, "treeview5"));
  GtkTreeStore *store2 = GTK_TREE_STORE(gtk_tree_view_get_model(tree2));
  NetMDDisc *disc = md->disc;
  NetMDGroup *group = disc->groups[group_number];
  int i;

  gtk_tree_store_clear(store2);

  if ((group->first_track == -1) || (group->last_track == -1)) {
    current_first_track = 0; // FIXME: global usage
    return;
  }

  for (i = group->first_track; i <= group->last_track; i++) {
    char t[32];
    GtkTreeIter iter3;
    NetMDTrack *track = disc->tracks[i];
    gtk_tree_store_append(store2, &iter3, NULL);
    gtk_tree_store_set(store2, &iter3,
                       TRACK_COLUMN, track->track_number + 1,
                       TITLE_COLUMN, track->title,
                       LENGTH_COLUMN, netmd_track_time_s(track, t, 32),
                       MODE_COLUMN, netmd_track_bitrate_s(track),
                       CODEC_COLUMN, netmd_track_codec_s(track), -1);
  }
  current_first_track = group->first_track; // FIXME: global usage
}

void on_nothing_selected() {
  GtkTreeView *tree2 = GTK_TREE_VIEW(lookup_widget(a, "treeview5"));
  GtkTreeStore *store2 = GTK_TREE_STORE(gtk_tree_view_get_model(tree2));
  gtk_tree_store_clear(store2);
}

void on_cursor_changed(GtkTreeView *treeview, gpointer data) {
  GtkTreePath *path;
  GtkTreeViewColumn *col;
  int *indices;
  int depth;
  gtk_tree_view_get_cursor(treeview, &path, &col);
  depth = gtk_tree_path_get_depth(path);
  indices = gtk_tree_path_get_indices(path);
  if (depth == 3) {
    //printf("group %d\n", indices[2]);
    on_group_selected(indices[2]);
  } else if (depth == 2 && indices[1] == 1) {
    //printf("all tracks\n");
    on_all_tracks_selected();
  } else {
    on_nothing_selected();
  }
}

void on_row_changed(GtkTreeModel *tree_model, GtkTreePath *path,
                    GtkTreeIter *iter) {
  printf("on_row_changed(%p,...)\n", tree_model);
}

void on_row_inserted(GtkTreeModel *tree_model, GtkTreePath *path,
                     GtkTreeIter *iter) {
  printf("on_row_inserted(%p,...)\n", tree_model);
}

void on_row_deleted(GtkTreeModel *tree_model, GtkTreePath *path) {
  printf("on_row_deleted(%p,...)\n", tree_model);
}

void on_rows_reordered(GtkTreeModel *tree_model, GtkTreePath *path,
                       GtkTreeIter *iter, gint *new_order) {
  printf("on_rows_reordered(%p,...)\n", tree_model);
}

void on_rescan1_activate(GtkWidget *widget, gpointer user_data) {
  GtkEntry *disctitle_widget;
  GtkCList *table_widget;
  GtkTreeIter iter1, iter2;
  GtkTreeView *tree1 = GTK_TREE_VIEW(lookup_widget(a, "treeview4"));
  int i = 0;
  GtkTreeIter iter3;
  GtkTreeStore *store1, *store2;

  NetMDDisc *disc = netmd_get_disc(md);

  if (disc == NULL)
    return;

  store1 = gtk_tree_store_new(1, G_TYPE_STRING);
  gtk_tree_view_set_model(GTK_TREE_VIEW(tree1), GTK_TREE_MODEL(store1));
  g_object_unref(G_OBJECT(store1));
  gtk_tree_store_clear(store1);

  gtk_tree_store_append(store1, &iter1, NULL);
  gtk_tree_store_set(store1, &iter1, 0, disc->name, -1);

  gtk_tree_store_append(store1, &iter2, &iter1);
  gtk_tree_store_set(store1, &iter2, 0, "Groups", -1);
  gtk_tree_store_append(store1, &iter3, &iter1);
  gtk_tree_store_set(store1, &iter3, 0, "All Tracks", -1);

  for (i = 0; i < disc->numgroups; i++) {
    NetMDGroup *g = disc->groups[i];
    int j, lasttrack = g->last_track;
    gtk_tree_store_append(store1, &iter3, &iter2);
    gtk_tree_store_set(store1, &iter3, 0, g->name, -1);
  }

  gtk_tree_view_expand_all(tree1);
}

void on_about1_activate(GtkMenuItem *menuitem, gpointer user_data) {
  GtkWidget *about = create_about2();
  gtk_widget_show(about);
}

void
on_discproperties_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_import_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_trackproperties_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_clear1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

void
on_play1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  netmd_playback_start(md);
}


void
on_stop1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  netmd_playback_stop(md);
}


void
on_forward1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  netmd_playback_ff(md);
}


void
on_back1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  netmd_playback_rew(md);
}


void
on_pause1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  netmd_playback_pause(md);
}


void
on_refresh1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  on_rescan1_activate(0,0);
}

