#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <libgnomevfs/gnome-vfs.h>
#include <libgnomevfs/gnome-vfs-method.h>
#include <libgnomevfs/gnome-vfs-module.h>
//#include <libgnomevfs/gnome-vfs-module-shared.h>
#include <libgnomevfs/gnome-vfs-module-callback-module-api.h>
#include <libgnomevfs/gnome-vfs-standard-callbacks.h>


static GnomeVFSResult
do_open_directory (GnomeVFSMethod *method,
                   GnomeVFSMethodHandle **method_handle, GnomeVFSURI *uri,
                   GnomeVFSFileInfoOptions options, GnomeVFSContext *context)
{
  printf("do_open_directory() called\n");
}

static GnomeVFSResult
do_close_directory (GnomeVFSMethod *method,
                    GnomeVFSMethodHandle *method_handle,
                    GnomeVFSContext *context)
{
  printf("do_close_directory() called\n");
}

static GnomeVFSResult
do_read_directory (GnomeVFSMethod *method,
                   GnomeVFSMethodHandle *method_handle,
                   GnomeVFSFileInfo *file_info,
                   GnomeVFSContext *context)
{
  printf("do_read_directory() called\n");
}

static GnomeVFSResult
do_get_file_info (GnomeVFSMethod *method,
                  GnomeVFSURI *uri,
                  GnomeVFSFileInfo *vfs_file_info,
                  GnomeVFSFileInfoOptions options,
                  GnomeVFSContext *context)
{
  printf("do_get_file_info() called\n");
}

static gboolean
do_is_local (GnomeVFSMethod *method,
             const GnomeVFSURI *uri)
{
  return FALSE;
}

/*
void do_make_directory(void) {
  printf("do_make_directory() called\n");
}

void do_remove_directory(void) {
  printf("do_remove_directory() called\n");
}
*/

/*
void do_move(void) {
  printf("do_move() called\n");
}

void do_unlink(void) {
  printf("do_unlink() called\n");
}

void do_check_same_fs(void) {
  printf("do_check_same_fs() called\n");
}

void do_set_file_info(void) {
  printf("do_set_file_info() called\n");
}
*/

static GnomeVFSMethod method = {
        sizeof (GnomeVFSMethod),
        0, /*do_open*/
        0, /*do_create*/
        0, /*do_close*/
        0, /*do_read*/
        0, /*do_write*/
        0, /*do_seek*/
        0, /*do_tell*/
        NULL, /* do_truncate_handle, */
        do_open_directory,
        do_close_directory,
        do_read_directory,
        do_get_file_info,
        NULL, /* do_get_file_info_from_handle, */
        do_is_local,
0,0,0,0,0,0,
        /*do_make_directory,
        do_remove_directory,
        do_move,
        do_unlink,
        do_check_same_fs,
        do_set_file_info,*/
        NULL, /* do_truncate, */
        NULL, /* do_find_directory, */
        NULL /* do_create_symbolic_link */
};

GnomeVFSMethod *vfs_module_init(const char *method_name, const char *args) {
  dprintf("vfs_module_init() called\n");
  return &method;
}

void vfs_module_shutdown(GnomeVFSMethod *method) {
  dprintf("vfs_module_shutdown() called\n");
}
